Regex support in matcher-values of smart variables and parameters
Status: New   

Priority: Normal   

Assignee:    

Category: Parameters   

Target version:    

Difficulty:  Fixed in Releases:  

Triaged:  Found in Releases:  

Bugzilla link: 1132453 Red Hat JIRA:  

Pull request:    

Description

The following would be nice functionality I think

Matching on something like: os =~ ^RedHat 6.* would greatly simplify doing stuff for different major versions of a specific distro.

lsbdistcodename is insufficient as all versions of CentOS report Final as codename.

operatingsystemmajrelease is insufficient as well, as that will also match Debian 6.x

Alternatively matching multiple facts using and/or logic would work as well.

osfamily = RedHat and (&&) operatingsystemmajrelease = 6

Related issues:

Related to Foreman - Feature #3848: Matcher value for smart variables against... New 12/11/2013

Related to Foreman - Feature #3309: Support deep merging of hash structures i... Closed 10/17/2013

Related to Foreman - Tracker #4470: Usability of parameters and overrides New

History

#1 - 11/12/2013 04:54 PM - Dominic Cleal

- Category set to Parameters

#2 - 12/11/2013 09:59 AM - Dominic Cleal

- Related to Feature #3848: Matcher value for smart variables against array added

#3 - 03/05/2014 02:42 PM - Finke Lamein

As extra sidenote:

as it stands now, there seems to be no way to differentiate between different CentOS major versions.

all the known facts, regarding OS versions

lsbmajdistrelease             6

operatingsystemmajrelease     6

operatingsystemrelease             6.4

lsbdistrelease                     6.4

operatingsystem             CentOS

lsbdistid                     CentOS

lsbdistdescription             CentOS release 6.4 (Final) <--- Using regexes we could match this one as "^CentOS release 6\."

lsbdistcodename             Final   <--- this one being the major culprit, All CentOS releases are codenamed Final

osfamily                     RedHat

#4 - 06/05/2014 01:19 PM - Ordina Cloud Solutions

We actually fixed this use case with a custom fact as follows:

Facter.add("familygeneration") do

setcode do
family = Facter.value('osfamily')

major = Facter.value('operatingsystemmajrelease')

major = Facter.value('lsbmajdistrelease') if major.nil?

family + " " + major

end

end

Probably there are still some use cases in which regex support is more neat.

Greetings Finke

#5 - 08/20/2014 03:07 AM - Ohad Levy

- Related to Feature #3309: Support deep merging of hash structures in smart class parameters added

#6 - 08/20/2014 03:19 AM - Ori Rabin

- Status changed from New to Assigned

- Assignee set to Ori Rabin

#7 - 08/21/2014 06:44 AM - Dominic Cleal

- Target version set to 1.7.4

#8 - 08/21/2014 07:42 AM - Stephen Benjamin

- Subject changed from Regex support in matcher-values of smart variables to Regex support in matcher-values of smart variables and parameters

Would be useful for smart class parameters as well.

#9 - 08/21/2014 07:42 AM - Stephen Benjamin

- Bugzilla link set to 1132453

#10 - 09/10/2014 07:19 AM - Anonymous

- Target version changed from 1.7.4 to 1.7.3

#11 - 09/16/2014 09:10 AM - Ohad Levy

- Target version deleted (1.7.3)

#12 - 10/23/2014 10:38 AM - Ori Rabin

- Related to Tracker #4470: Usability of parameters and overrides added

#13 - 08/11/2015 09:49 AM - Ori Rabin

- Status changed from Assigned to New

- Assignee deleted (Ori Rabin)
